$! Script to edit http server configuration files.
$! Request is of form:
$!          script name | path-info
$!   GET  /htbin/cnfedit/fname/version
$!   GET  /htbin/cnfedit/fname/version?Innn
$!   GET  /htbin/cnfedit/fname/version?Ennn
$!   POST /htbin/cnfedit/fname/version/Innn
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! First parse request and locate target file.
$ sv = f$verify(1)
$ src_dir = "www_system:"
$ conf_dir = "www_root:[cnfedit]"
$ temp = f$search("www_root:[000000]cnfedit.dir;1")
$ if temp .eqs. ""
$ then
$!    make shadow directory
$    create/director/prot=(world,owner:rwed) www_root:[cnfedit]
$    backup 'src_dir'*.conf; 'conf_dir'
$ endif
$ write net_link "<DNETRECMODE>"
$ CGI_SYMBOLS
$ out = "write net_link"
$ if f$type(WWW_PATH_INFO) .eqs. "" then WWW_PATH_INFO = ""
$ cfile = f$element(1,"/",WWW_PATH_INFO)
$ version = f$element(2,"/",WWW_PATH_INFO)
$ arg = "''WWW_QUERY_STRING'"
$ fullcfile = f$parse(conf_dir+cfile+";",".conf")
$ latest = f$search(fullcfile)
$ if latest .eqs. ""
$ then
$    out "content-type: text/plain", f$fao("!/")
$    out "Unable to locate '", cfile, ";' in configuration directory"
$    exit
$ endif
$ 
$ cfile_v=cfile+"/"+f$element(1,";",f$parse(latest,,,"VERSION","SYNTAX_ONLY"))
$ if cfile_v .nes. cfile+"/"+version
$ then
$    port = ":" + www_server_port
$    if port .eqs. ":80" then port = ""
$    if arg .nes. "" .or. www_request_method .nes. "GET"
$    then
$	out "content-type: text/html", f$fao("!/")
$	out "<HTML><HEAD><TITLE>Configuration update</TITLE></HEAD><BODY>"
$	out "Requested file has been updated, <A HREF=""http://", -
		www_server_name, port, www_script_name, cfile_v,-
		""">reload</A> newer version.
$	out "</BODY></HTML>"
$	exit
$    endif
$    out "location: http://",www_server_name,port,www_script_name,"/", -
	cfile_v, f$fao("!/")
$    exit
$ endif
$ if arg .eqs. "" then arg = "X0"
$ out "content-type: text/html" + f$fao("!/")
$ if cfile .eqs. "/" then goto bad_file
$ set noverify
$ rule_userdir = "UserDir sub-dir/20/20"
$ rule_fail = "Fail template/40/200"
$ rule_map = "Map template/40/200 result/40/200"
$ rule_pass = "Pass template/40/200 result/40/200"
$ rule_exec = "Exec template/40/200 bin-directory/40/200"
$ rule_redirect = "Redirect template/40/200 result/40/200"
$ rule_usermap = "UserMap template/40/200 map-arg/40/100 image-arg/40/100"
$ rule_dnslookup = "DNSLookup state/0/on/off"
$ rule_diraccess = "DirAccess state/0/on/off/selective control-file/40/200"
$ rule_welcome = "Welcome file-name/40/200"
$ rule_authenticator = "Authenticator auth/40/200"
$ rule_defprot = "DefProt template/40/200 prot-file/40/200"
$ rule_hostprot = "HostProt template/40/200 prot-file/40/200"
$ rule_protect = "Protect template/40/200 prot-file/40/200"
$ rule_include = "Include file/60/240"
$ rule_search = "Search script/40/200"
$ rule_suffix = "Suffix extension/20/40 content-type/30/80 encoding/10/20 quality/10/20"
$ rule_presentation = "Presentation content-type/30/80 script/20/80"
$ rule_accesslog = "AccessLog logfile/40/200"
$ known_rules = ",map,pass,exec,redirect,userdir,dnslookup,diraccess," + -
   "authenticator,search,suffix,include,presentation,fail,usermap,welcome," + -
   "defprot,hostprot,protect,accesslog,"
$!
$! Read file into symbol table, vars of form line_'lnum'
$ open cnf/read/error=bad_file 'fullcfile'
$ line_count = 0
$ read = "read"
$ load_next:
$    line_count = line_count + 1
$    read cnf line_'line_count'/end=load_done/error=load_error
$    goto load_next
$ load_error:
$    message = f$message($status)
$    close cnf
$    out "<HTML><BODY>"
$    out "Read error on file: ", message
$    out "</BODY></HTML>"
$    exit
$ bad_file:
$    out "<HTML><BODY>"
$    out "--Error opening configuration file '", cfile, "'."
$    out "</BODY></HTML>"
$    exit
$ load_done:
$ line_count = line_count - 1
$ close cnf
$!
$ if www_request_method .eqs. "POST" then goto  do_post
$ if www_request_method .nes. "GET"
$ then
$    out "<HTML><BODY>"
$    out "Illegal method (",www_request_method,") in request"
$    out "</BODY></HTML>"
$    exit
$ endif
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ out "<HTML><HEAD><TITLE>HTTP Server ",CFILE," configuration.</TITLE></HEAD>"
$ create net_link:
<BODY>
This page is used to display/edit a configuration file used by the OSU
DECthreads HTTP server.
<DL><DT>Key for links</DT>
<DD><DL>
<DT>+</DT><DD>Places  form for adding new rule or comment and indicated
spot<P></DD>
<DT>!</DT><DD>Brings up form for editing comment field.<P></DD>
<DT>'rule-name'</DT><DD>Brings up form for editing rule</DD>
</DL></DD>
</DL>
<HR><PRE>
$ lnum = 0
$ anum = f$integer(f$extract(1,10,arg))		! line number to act upon
$ insert_mode = f$extract(0,1,arg) .eqs. "I"
$ in_comment = 0
$ in_continue = 0
$!
$ on warning then goto scan_done
$ next_line:
$    lnum = lnum + 1
$    tag = f$string(lnum)
$    header = "<A HREF=""''version'?I" + tag + "#add"">+</A>: "
$    if lnum .eq. anum .and. insert_mode then gosub output_insert_form
$!
$    if lnum .gt. line_count then goto scan_done
$    line = f$edit(line_'lnum',"TRIM")
$    if line .eqs. "" then goto next_line
$!
$    if f$extract(0,1,f$edit(line,"TRIM")) .eqs. "#"
$    then
$	off = f$locate("#",line)
$       if in_comment 
$	then 
$	    header = "     "
$           marker = " "
$	else
$	    marker = "<A HREF=""''version'?C" + tag + "#edit"">!</A>"
$	endif
$       if lnum .eq. anum .and. .not. insert_mode 
$	then 
$	    gosub output_cedit_form
$	else
$	    out header+f$extract(0,off,line)+marker+f$extract(off+1,99,line)
$	endif
$	in_comment = 1
$    else
$	line = f$edit(line,"TRIM,COMPRESS")
$       if in_continue
$	then 
$	    header = "     "
$           marker = ""
$	    rule = ""
$	else
$	    rule = f$element(0," ",line)
$	    marker = "<A HREF=""''version'?R" + tag + "#edit"">" + rule + "</A>"
$	    line = f$extract(f$length(rule),f$length(line),line)
$	endif
$	
$       in_comment = 0
$	in_continue = f$locate("\",line) .eq. (f$length(line)-1)
$       if lnum .eq. anum .and. .not. insert_mode then gosub output_redit_form
$	if f$edit(rule,"UPCASE") .eqs. "INCLUDE" then gosub output_include_rule
$       out header,marker,line
$    endif
$    goto next_line
$ scan_done:
$ out header,"[EOF]"
$ cleanup:
$ out "</BODY></HTML>"
$ sv = f$verify(sv)
$ exit
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! make included file a hot-link.
$ output_include_rule:
$ cooked_line = f$edit(line,"TRIM,COMPRESS")
$ href = f$edit(f$element(0," ",cooked_line),"UPCASE")
$ href_l = f$length(href)
$ if f$extract(0,11,href) .eqs. "WWW_SYSTEM:" then href = f$extract(11,80,href)
$ inc_flush:
$ line = " <A HREF="""+www_script_name+"/"+HREF+""">"+  -
   f$extract(0,href_l,cooked_line)+"</A>"+ -
   f$extract(href_l,f$length(cooked_line),cooked_line)
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ output_insert_form:
$ out "<A name=""add"">*:</A>"
$ out "<FORM method=""POST"" action=""", www_script_name,"/",cfile_v,""">"
$!
$! The theory on which rules to put directly in the insert form is to
$! limit it to those rules likely to be added, single instance rules for
$! the global parameters (e.g. DNSlookup) are likely already in the 
$! configuration file so won't be inserted.
$!
$ create net_link:
<input type="submit" value = " Insert "><select name="rtype"><option>! (comment)
<option>exec<option>fail<option>map<option>pass<option>redirect
<option>suffix<option>include<option>hostprot<option>protect
<option>more...</select> args: <input name="rtext" type="text" size=40 maxlength=90>
</FORM>
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ output_redit_form:
$ out header
$ set verify
$! template format: command arg1/size/max arg2/size/max
$ out "<A name=""edit"">[</A>"
$ out "<FORM method=""POST"" action=""", www_script_name,"/",cfile_v,""">"
$ out "Rule: <select name="rtype" value=""''rule'""><option>''rule'<option>(other)</select>"
$ screen = "," + f$edit(rule,"LOWERCASE") + ","
$! if f$locate(screen,known_rules) .ge. f$length(known_rules) then goto other_only
$ if f$locate(screen,known_rules) .ge. f$length(known_rules)
$ then
$     out "   args: <input type=""text"" name=""args"" value=""", -
		line, """ size=60 maxlength=240>"
$     rule = "unknown"
$     rule_unknown = "Unknown"
$ endif
$!
$ i = 0
$ next_r_arg:
$     i = i + 1
$     tname = f$element(0,"/",f$element(i," ",rule_'rule'))
$     if tname .eqs. " " then goto other_only
$     tsize = f$element(1,"/",f$element(i," ",rule_'rule'))
$     tmax = f$element(2,"/",f$element(i," ",rule_'rule'))
$     val = f$element(i," ",line)
$     out "   ",tname,": <input type=""text"" name=""", tname, """ value=""", -
		val, """ size=''tsize' maxlength=''tmax'>"
$    goto next_r_arg
$ other_only:
$ set noverify
$ out "Other rule: <input type=""text"" name=""other"" size=12 maxlength=40>" + -
	" args: <input type=""text"" name=""otharg"" size=45 maxlength=200>"
$ out "<input type=""submit"" value = "" Update "">"
$ header = ""
$ marker = ""
$ line = "</FORM>]"
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ output_cedit_form:
$ out header
$ out "<A name=""edit"">*:</A>"
$ out "<FORM method=""POST"" action=""", www_script_name,"/",cfile_v,""">"
$ out "Comment: <input type=""text"" name="comment" size=60 maxlength=250>
$ out "<input type=""submit"" value = "" Update "">"
$ out "</FORM>"
$ return
$!=========================================================================
$!=========================================================================
$ do_post:
$ i = 1
$ new_version = f$integer(version) + 1
$ out "Later"
