$!
$! Install appropriate tserver_tcpshr image.  First make list of tserver_*
$! images in www_system (abort early if none), then choose appropriate
$! image.
$!
$ flist = ""
$ next_file:
$    image = f$search("www_system:tserver_*.exe;")
$    flist = flist + "," + f$parse(image,,,"NAME")
$    if image .nes. "" then goto next_file
$ if flist .eqs. "," then exit		! empty list.
$ flist = flist + ","
$ show symbol flist
$!
$!  Search for first image that meets criteria for selection:
$!	1. tserver_tcpshr.exe, if present, is used unconditionally (allows
$!	   sysadmin to choose image by copying apprpopriate image.
$!	2. tserver_multinetp.exe, if present and logical name
$!	    multinet_socket_library (shareable image dependancy).
$!	3. tserver_ucxtcp.exe, if present.
$!	4. first tserver_* image found.
$!
$ flist_len = f$length(flist)
$ if f$locate(",TSERVER_TCPSHR,",flist) .lt. flist_len
$ then
$    tserver_image = "WWW_SYSTEM:TSERVER_TCPSHR.EXE"
$    goto install_image
$ endif
$!
$ if f$locate(",TSERVER_MULTINET,",flist) .lt. flist_len .and. -
	f$trnlnm("MULTINET_SOCKET_LIBRARY") .NES. ""
$ then
$    tserver_image = "WWW_SYSTEM:TSERVER_MULTINET.EXE"
$    goto install_image
$ endif
$!
$ if f$locate(",TSERVER_UCXTCP,",flist) .lt. flist_len 
$ then
$    tserver_image = "WWW_SYSTEM:TSERVER_UCXTCP.EXE"
$    goto install_image
$ endif
$!
$ tserver_image = "WWW_SYSTEM:" + f$element(1,",",flist) + ".EXE"
$!
$ install_image:
$ action = "add"
$ if f$file(tserver_image,"KNOWN") then action = "replace"
$ define/sys/exec tserver_tcpshr 'tserver_image
$ install 'action' 'tserver_image'
